##// END OF EJS Templates
Fixed: Added device-tree-compiler for U-Boot
drtyhlpr -
r114:eb123bc9784b
parent child
Show More
@@ -1,570 +1,575
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2016
4 # rpi23-gen-image.sh 2015-2016
5 #
5 #
6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 10+ github contributors!
15 # Big thanks for patches and enhancements by 10+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Introduce settings
33 # Introduce settings
34 set -e
34 set -e
35 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
35 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
36 set -x
36 set -x
37
37
38 # Raspberry Pi model configuration
38 # Raspberry Pi model configuration
39 RPI_MODEL=${RPI_MODEL:=2}
39 RPI_MODEL=${RPI_MODEL:=2}
40 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
40 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
41 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
41 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
42 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
42 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
43 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
43 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=jessie}
46 RELEASE=${RELEASE:=jessie}
47 KERNEL_ARCH=${KERNEL_ARCH:=arm}
47 KERNEL_ARCH=${KERNEL_ARCH:=arm}
48 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
48 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
49 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
49 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
50 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
50 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
51 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
51 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
52 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
52 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
53 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
53 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
54
54
55 # URLs
55 # URLs
56 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
57 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
58 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
58 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
59 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
59 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
60 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
60 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
61 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
61 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
62
62
63 # Build directories
63 # Build directories
64 BASEDIR="$(pwd)/images/${RELEASE}"
64 BASEDIR="$(pwd)/images/${RELEASE}"
65 BUILDDIR="${BASEDIR}/build"
65 BUILDDIR="${BASEDIR}/build"
66
66
67 # Chroot directories
67 # Chroot directories
68 R="${BUILDDIR}/chroot"
68 R="${BUILDDIR}/chroot"
69 ETC_DIR="${R}/etc"
69 ETC_DIR="${R}/etc"
70 LIB_DIR="${R}/lib"
70 LIB_DIR="${R}/lib"
71 BOOT_DIR="${R}/boot/firmware"
71 BOOT_DIR="${R}/boot/firmware"
72 KERNEL_DIR="${R}/usr/src/linux"
72 KERNEL_DIR="${R}/usr/src/linux"
73 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
73 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
74
74
75 # Firmware directory: Blank if download from github
75 # Firmware directory: Blank if download from github
76 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
76 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
77
77
78 # General settings
78 # General settings
79 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
79 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
80 PASSWORD=${PASSWORD:=raspberry}
80 PASSWORD=${PASSWORD:=raspberry}
81 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
81 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
82 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
82 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
83 EXPANDROOT=${EXPANDROOT:=true}
83 EXPANDROOT=${EXPANDROOT:=true}
84
84
85 # Keyboard settings
85 # Keyboard settings
86 XKB_MODEL=${XKB_MODEL:=""}
86 XKB_MODEL=${XKB_MODEL:=""}
87 XKB_LAYOUT=${XKB_LAYOUT:=""}
87 XKB_LAYOUT=${XKB_LAYOUT:=""}
88 XKB_VARIANT=${XKB_VARIANT:=""}
88 XKB_VARIANT=${XKB_VARIANT:=""}
89 XKB_OPTIONS=${XKB_OPTIONS:=""}
89 XKB_OPTIONS=${XKB_OPTIONS:=""}
90
90
91 # Network settings (DHCP)
91 # Network settings (DHCP)
92 ENABLE_DHCP=${ENABLE_DHCP:=true}
92 ENABLE_DHCP=${ENABLE_DHCP:=true}
93
93
94 # Network settings (static)
94 # Network settings (static)
95 NET_ADDRESS=${NET_ADDRESS:=""}
95 NET_ADDRESS=${NET_ADDRESS:=""}
96 NET_GATEWAY=${NET_GATEWAY:=""}
96 NET_GATEWAY=${NET_GATEWAY:=""}
97 NET_DNS_1=${NET_DNS_1:=""}
97 NET_DNS_1=${NET_DNS_1:=""}
98 NET_DNS_2=${NET_DNS_2:=""}
98 NET_DNS_2=${NET_DNS_2:=""}
99 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
99 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
100 NET_NTP_1=${NET_NTP_1:=""}
100 NET_NTP_1=${NET_NTP_1:=""}
101 NET_NTP_2=${NET_NTP_2:=""}
101 NET_NTP_2=${NET_NTP_2:=""}
102
102
103 # APT settings
103 # APT settings
104 APT_PROXY=${APT_PROXY:=""}
104 APT_PROXY=${APT_PROXY:=""}
105 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
105 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
106
106
107 # Feature settings
107 # Feature settings
108 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
108 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
109 ENABLE_IPV6=${ENABLE_IPV6:=true}
109 ENABLE_IPV6=${ENABLE_IPV6:=true}
110 ENABLE_SSHD=${ENABLE_SSHD:=true}
110 ENABLE_SSHD=${ENABLE_SSHD:=true}
111 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
111 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
112 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
112 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
113 ENABLE_SOUND=${ENABLE_SOUND:=true}
113 ENABLE_SOUND=${ENABLE_SOUND:=true}
114 ENABLE_DBUS=${ENABLE_DBUS:=true}
114 ENABLE_DBUS=${ENABLE_DBUS:=true}
115 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
115 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
116 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
116 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
117 ENABLE_XORG=${ENABLE_XORG:=false}
117 ENABLE_XORG=${ENABLE_XORG:=false}
118 ENABLE_WM=${ENABLE_WM:=""}
118 ENABLE_WM=${ENABLE_WM:=""}
119 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
119 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
120 ENABLE_USER=${ENABLE_USER:=true}
120 ENABLE_USER=${ENABLE_USER:=true}
121 USER_NAME=${USER_NAME:="pi"}
121 USER_NAME=${USER_NAME:="pi"}
122 ENABLE_ROOT=${ENABLE_ROOT:=false}
122 ENABLE_ROOT=${ENABLE_ROOT:=false}
123 ENABLE_ROOT_SSH=${ENABLE_ROOT_SSH:=false}
123 ENABLE_ROOT_SSH=${ENABLE_ROOT_SSH:=false}
124
124
125 # Advanced settings
125 # Advanced settings
126 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
126 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
127 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
127 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
128 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
128 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
129 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
129 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
130 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
131 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
131 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
132 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
132 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
133 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
133 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
134 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
134 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
135
135
136 # Kernel compilation settings
136 # Kernel compilation settings
137 BUILD_KERNEL=${BUILD_KERNEL:=false}
137 BUILD_KERNEL=${BUILD_KERNEL:=false}
138 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
138 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
139 KERNEL_THREADS=${KERNEL_THREADS:=1}
139 KERNEL_THREADS=${KERNEL_THREADS:=1}
140 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
140 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
141 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
141 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
142 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
142 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
143
143
144 # Kernel compilation from source directory settings
144 # Kernel compilation from source directory settings
145 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
145 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
146 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
146 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
147 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
147 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
148 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
148 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
149
149
150 # Reduce disk usage settings
150 # Reduce disk usage settings
151 REDUCE_APT=${REDUCE_APT:=true}
151 REDUCE_APT=${REDUCE_APT:=true}
152 REDUCE_DOC=${REDUCE_DOC:=true}
152 REDUCE_DOC=${REDUCE_DOC:=true}
153 REDUCE_MAN=${REDUCE_MAN:=true}
153 REDUCE_MAN=${REDUCE_MAN:=true}
154 REDUCE_VIM=${REDUCE_VIM:=false}
154 REDUCE_VIM=${REDUCE_VIM:=false}
155 REDUCE_BASH=${REDUCE_BASH:=false}
155 REDUCE_BASH=${REDUCE_BASH:=false}
156 REDUCE_HWDB=${REDUCE_HWDB:=true}
156 REDUCE_HWDB=${REDUCE_HWDB:=true}
157 REDUCE_SSHD=${REDUCE_SSHD:=true}
157 REDUCE_SSHD=${REDUCE_SSHD:=true}
158 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
158 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
159
159
160 # Encrypted filesystem settings
160 # Encrypted filesystem settings
161 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
161 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
162 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
162 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
163 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
163 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
164 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
164 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
165 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
165 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
166
166
167 # Stop the Crypto Wars
167 # Stop the Crypto Wars
168 DISABLE_FBI=${DISABLE_FBI:=false}
168 DISABLE_FBI=${DISABLE_FBI:=false}
169
169
170 # Chroot scripts directory
170 # Chroot scripts directory
171 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
171 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
172
172
173 # Packages required in the chroot build environment
173 # Packages required in the chroot build environment
174 APT_INCLUDES=${APT_INCLUDES:=""}
174 APT_INCLUDES=${APT_INCLUDES:=""}
175 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
175 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
176
176
177 # Packages required for bootstrapping
177 # Packages required for bootstrapping
178 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc"
178 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc"
179 MISSING_PACKAGES=""
179 MISSING_PACKAGES=""
180
180
181 set +x
181 set +x
182
182
183 # Set Raspberry Pi model specific configuration
183 # Set Raspberry Pi model specific configuration
184 if [ "$RPI_MODEL" = 2 ] ; then
184 if [ "$RPI_MODEL" = 2 ] ; then
185 DTB_FILE=${RPI2_DTB_FILE}
185 DTB_FILE=${RPI2_DTB_FILE}
186 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
186 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
187 elif [ "$RPI_MODEL" = 3 ] ; then
187 elif [ "$RPI_MODEL" = 3 ] ; then
188 DTB_FILE=${RPI3_DTB_FILE}
188 DTB_FILE=${RPI3_DTB_FILE}
189 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
189 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
190 BUILD_KERNEL=true
190 BUILD_KERNEL=true
191 else
191 else
192 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
192 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
193 exit 1
193 exit 1
194 fi
194 fi
195
195
196 # Check if the internal wireless interface is supported by the RPi model
196 # Check if the internal wireless interface is supported by the RPi model
197 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
197 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
198 echo "error: The selected Raspberry Pi model has no internal wireless interface"
198 echo "error: The selected Raspberry Pi model has no internal wireless interface"
199 exit 1
199 exit 1
200 fi
200 fi
201
201
202 # Set compiler packages and build RPi2/3 Linux kernel if required by Debian release
202 # Set compiler packages and build RPi2/3 Linux kernel if required by Debian release
203 if [ "$RELEASE" = "jessie" ] ; then
203 if [ "$RELEASE" = "jessie" ] ; then
204 COMPILER_PACKAGES="linux-compiler-gcc-4.8-arm g++ make bc"
204 COMPILER_PACKAGES="linux-compiler-gcc-4.8-arm g++ make bc"
205 elif [ "$RELEASE" = "stretch" ] ; then
205 elif [ "$RELEASE" = "stretch" ] ; then
206 COMPILER_PACKAGES="linux-compiler-gcc-5-arm g++ make bc"
206 COMPILER_PACKAGES="linux-compiler-gcc-5-arm g++ make bc"
207 BUILD_KERNEL=true
207 BUILD_KERNEL=true
208 else
208 else
209 echo "error: Debian release ${RELEASE} is not supported!"
209 echo "error: Debian release ${RELEASE} is not supported!"
210 exit 1
210 exit 1
211 fi
211 fi
212
212
213 # Add packages required for kernel cross compilation
213 # Add packages required for kernel cross compilation
214 if [ "$BUILD_KERNEL" = true ] ; then
214 if [ "$BUILD_KERNEL" = true ] ; then
215 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
215 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
216 fi
216 fi
217
217
218 # Add libncurses5 to enable kernel menuconfig
218 # Add libncurses5 to enable kernel menuconfig
219 if [ "$KERNEL_MENUCONFIG" = true ] ; then
219 if [ "$KERNEL_MENUCONFIG" = true ] ; then
220 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
220 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
221 fi
221 fi
222
222
223 # Stop the Crypto Wars
223 # Stop the Crypto Wars
224 if [ "$DISABLE_FBI" = true ] ; then
224 if [ "$DISABLE_FBI" = true ] ; then
225 ENABLE_CRYPTFS=true
225 ENABLE_CRYPTFS=true
226 fi
226 fi
227
227
228 # Add cryptsetup package to enable filesystem encryption
228 # Add cryptsetup package to enable filesystem encryption
229 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
229 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
230 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
230 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
231 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
231 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
232
232
233 if [ -z "$CRYPTFS_PASSWORD" ] ; then
233 if [ -z "$CRYPTFS_PASSWORD" ] ; then
234 echo "error: no password defined (CRYPTFS_PASSWORD)!"
234 echo "error: no password defined (CRYPTFS_PASSWORD)!"
235 exit 1
235 exit 1
236 fi
236 fi
237 ENABLE_INITRAMFS=true
237 ENABLE_INITRAMFS=true
238 fi
238 fi
239
239
240 # Add initramfs generation tools
240 # Add initramfs generation tools
241 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
241 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
242 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
242 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
243 fi
243 fi
244
244
245 # Add device-tree-compiler required for building the U-Boot bootloader
246 if [ "$ENABLE_UBOOT" = true ] ; then
247 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
248 fi
249
245 # Check if all required packages are installed on the build system
250 # Check if all required packages are installed on the build system
246 for package in $REQUIRED_PACKAGES ; do
251 for package in $REQUIRED_PACKAGES ; do
247 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
252 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
248 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
253 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
249 fi
254 fi
250 done
255 done
251
256
252 # If there are missing packages ask confirmation for install, or exit
257 # If there are missing packages ask confirmation for install, or exit
253 if [ -n "$MISSING_PACKAGES" ] ; then
258 if [ -n "$MISSING_PACKAGES" ] ; then
254 echo "the following packages needed by this script are not installed:"
259 echo "the following packages needed by this script are not installed:"
255 echo "$MISSING_PACKAGES"
260 echo "$MISSING_PACKAGES"
256
261
257 echo -n "\ndo you want to install the missing packages right now? [y/n] "
262 echo -n "\ndo you want to install the missing packages right now? [y/n] "
258 read confirm
263 read confirm
259 [ "$confirm" != "y" ] && exit 1
264 [ "$confirm" != "y" ] && exit 1
260
265
261 # Make sure all missing required packages are installed
266 # Make sure all missing required packages are installed
262 apt-get -qq -y install ${MISSING_PACKAGES}
267 apt-get -qq -y install ${MISSING_PACKAGES}
263 fi
268 fi
264
269
265 # Check if ./bootstrap.d directory exists
270 # Check if ./bootstrap.d directory exists
266 if [ ! -d "./bootstrap.d/" ] ; then
271 if [ ! -d "./bootstrap.d/" ] ; then
267 echo "error: './bootstrap.d' required directory not found!"
272 echo "error: './bootstrap.d' required directory not found!"
268 exit 1
273 exit 1
269 fi
274 fi
270
275
271 # Check if ./files directory exists
276 # Check if ./files directory exists
272 if [ ! -d "./files/" ] ; then
277 if [ ! -d "./files/" ] ; then
273 echo "error: './files' required directory not found!"
278 echo "error: './files' required directory not found!"
274 exit 1
279 exit 1
275 fi
280 fi
276
281
277 # Check if specified KERNELSRC_DIR directory exists
282 # Check if specified KERNELSRC_DIR directory exists
278 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
283 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
279 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
284 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
280 exit 1
285 exit 1
281 fi
286 fi
282
287
283 # Check if specified CHROOT_SCRIPTS directory exists
288 # Check if specified CHROOT_SCRIPTS directory exists
284 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
289 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
285 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
290 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
286 exit 1
291 exit 1
287 fi
292 fi
288
293
289 # Check if specified device mapping already exists (will be used by cryptsetup)
294 # Check if specified device mapping already exists (will be used by cryptsetup)
290 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
295 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
291 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
296 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
292 exit 1
297 exit 1
293 fi
298 fi
294
299
295 # Don't clobber an old build
300 # Don't clobber an old build
296 if [ -e "$BUILDDIR" ] ; then
301 if [ -e "$BUILDDIR" ] ; then
297 echo "error: directory ${BUILDDIR} already exists, not proceeding"
302 echo "error: directory ${BUILDDIR} already exists, not proceeding"
298 exit 1
303 exit 1
299 fi
304 fi
300
305
301 # Setup chroot directory
306 # Setup chroot directory
302 mkdir -p "${R}"
307 mkdir -p "${R}"
303
308
304 # Check if build directory has enough of free disk space >512MB
309 # Check if build directory has enough of free disk space >512MB
305 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
310 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
306 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
311 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
307 exit 1
312 exit 1
308 fi
313 fi
309
314
310 set -x
315 set -x
311
316
312 # Call "cleanup" function on various signals and errors
317 # Call "cleanup" function on various signals and errors
313 trap cleanup 0 1 2 3 6
318 trap cleanup 0 1 2 3 6
314
319
315 # Add required packages for the minbase installation
320 # Add required packages for the minbase installation
316 if [ "$ENABLE_MINBASE" = true ] ; then
321 if [ "$ENABLE_MINBASE" = true ] ; then
317 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
322 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
318 fi
323 fi
319
324
320 # Add required locales packages
325 # Add required locales packages
321 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
326 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
322 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
327 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
323 fi
328 fi
324
329
325 # Add parted package, required to get partprobe utility
330 # Add parted package, required to get partprobe utility
326 if [ "$EXPANDROOT" = true ] ; then
331 if [ "$EXPANDROOT" = true ] ; then
327 APT_INCLUDES="${APT_INCLUDES},parted"
332 APT_INCLUDES="${APT_INCLUDES},parted"
328 fi
333 fi
329
334
330 # Add dbus package, recommended if using systemd
335 # Add dbus package, recommended if using systemd
331 if [ "$ENABLE_DBUS" = true ] ; then
336 if [ "$ENABLE_DBUS" = true ] ; then
332 APT_INCLUDES="${APT_INCLUDES},dbus"
337 APT_INCLUDES="${APT_INCLUDES},dbus"
333 fi
338 fi
334
339
335 # Add iptables IPv4/IPv6 package
340 # Add iptables IPv4/IPv6 package
336 if [ "$ENABLE_IPTABLES" = true ] ; then
341 if [ "$ENABLE_IPTABLES" = true ] ; then
337 APT_INCLUDES="${APT_INCLUDES},iptables"
342 APT_INCLUDES="${APT_INCLUDES},iptables"
338 fi
343 fi
339
344
340 # Add openssh server package
345 # Add openssh server package
341 if [ "$ENABLE_SSHD" = true ] ; then
346 if [ "$ENABLE_SSHD" = true ] ; then
342 APT_INCLUDES="${APT_INCLUDES},openssh-server"
347 APT_INCLUDES="${APT_INCLUDES},openssh-server"
343 fi
348 fi
344
349
345 # Add alsa-utils package
350 # Add alsa-utils package
346 if [ "$ENABLE_SOUND" = true ] ; then
351 if [ "$ENABLE_SOUND" = true ] ; then
347 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
352 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
348 fi
353 fi
349
354
350 # Add rng-tools package
355 # Add rng-tools package
351 if [ "$ENABLE_HWRANDOM" = true ] ; then
356 if [ "$ENABLE_HWRANDOM" = true ] ; then
352 APT_INCLUDES="${APT_INCLUDES},rng-tools"
357 APT_INCLUDES="${APT_INCLUDES},rng-tools"
353 fi
358 fi
354
359
355 # Add fbturbo video driver
360 # Add fbturbo video driver
356 if [ "$ENABLE_FBTURBO" = true ] ; then
361 if [ "$ENABLE_FBTURBO" = true ] ; then
357 # Enable xorg package dependencies
362 # Enable xorg package dependencies
358 ENABLE_XORG=true
363 ENABLE_XORG=true
359 fi
364 fi
360
365
361 # Add user defined window manager package
366 # Add user defined window manager package
362 if [ -n "$ENABLE_WM" ] ; then
367 if [ -n "$ENABLE_WM" ] ; then
363 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
368 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
364
369
365 # Enable xorg package dependencies
370 # Enable xorg package dependencies
366 ENABLE_XORG=true
371 ENABLE_XORG=true
367 fi
372 fi
368
373
369 # Add xorg package
374 # Add xorg package
370 if [ "$ENABLE_XORG" = true ] ; then
375 if [ "$ENABLE_XORG" = true ] ; then
371 APT_INCLUDES="${APT_INCLUDES},xorg"
376 APT_INCLUDES="${APT_INCLUDES},xorg"
372 fi
377 fi
373
378
374 # Replace selected packages with smaller clones
379 # Replace selected packages with smaller clones
375 if [ "$ENABLE_REDUCE" = true ] ; then
380 if [ "$ENABLE_REDUCE" = true ] ; then
376 # Add levee package instead of vim-tiny
381 # Add levee package instead of vim-tiny
377 if [ "$REDUCE_VIM" = true ] ; then
382 if [ "$REDUCE_VIM" = true ] ; then
378 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
383 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
379 fi
384 fi
380
385
381 # Add dropbear package instead of openssh-server
386 # Add dropbear package instead of openssh-server
382 if [ "$REDUCE_SSHD" = true ] ; then
387 if [ "$REDUCE_SSHD" = true ] ; then
383 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
388 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
384 fi
389 fi
385 fi
390 fi
386
391
387 # Configure kernel sources if no KERNELSRC_DIR
392 # Configure kernel sources if no KERNELSRC_DIR
388 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
393 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
389 KERNELSRC_CONFIG=true
394 KERNELSRC_CONFIG=true
390 fi
395 fi
391
396
392 # Configure reduced kernel
397 # Configure reduced kernel
393 if [ "$KERNEL_REDUCE" = true ] ; then
398 if [ "$KERNEL_REDUCE" = true ] ; then
394 KERNELSRC_CONFIG=false
399 KERNELSRC_CONFIG=false
395 fi
400 fi
396
401
397 # Execute bootstrap scripts
402 # Execute bootstrap scripts
398 for SCRIPT in bootstrap.d/*.sh; do
403 for SCRIPT in bootstrap.d/*.sh; do
399 head -n 3 "$SCRIPT"
404 head -n 3 "$SCRIPT"
400 . "$SCRIPT"
405 . "$SCRIPT"
401 done
406 done
402
407
403 ## Execute custom bootstrap scripts
408 ## Execute custom bootstrap scripts
404 if [ -d "custom.d" ] ; then
409 if [ -d "custom.d" ] ; then
405 for SCRIPT in custom.d/*.sh; do
410 for SCRIPT in custom.d/*.sh; do
406 . "$SCRIPT"
411 . "$SCRIPT"
407 done
412 done
408 fi
413 fi
409
414
410 # Execute custom scripts inside the chroot
415 # Execute custom scripts inside the chroot
411 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
416 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
412 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
417 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
413 chroot_exec /bin/bash -x <<'EOF'
418 chroot_exec /bin/bash -x <<'EOF'
414 for SCRIPT in /chroot_scripts/* ; do
419 for SCRIPT in /chroot_scripts/* ; do
415 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
420 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
416 $SCRIPT
421 $SCRIPT
417 fi
422 fi
418 done
423 done
419 EOF
424 EOF
420 rm -rf "${R}/chroot_scripts"
425 rm -rf "${R}/chroot_scripts"
421 fi
426 fi
422
427
423 # Remove apt-utils
428 # Remove apt-utils
424 if [ "$RELEASE" = "jessie" ] ; then
429 if [ "$RELEASE" = "jessie" ] ; then
425 chroot_exec apt-get purge -qq -y --force-yes apt-utils
430 chroot_exec apt-get purge -qq -y --force-yes apt-utils
426 fi
431 fi
427
432
428 # Generate required machine-id
433 # Generate required machine-id
429 MACHINE_ID=$(dbus-uuidgen)
434 MACHINE_ID=$(dbus-uuidgen)
430 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
435 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
431 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
436 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
432
437
433 # APT Cleanup
438 # APT Cleanup
434 chroot_exec apt-get -y clean
439 chroot_exec apt-get -y clean
435 chroot_exec apt-get -y autoclean
440 chroot_exec apt-get -y autoclean
436 chroot_exec apt-get -y autoremove
441 chroot_exec apt-get -y autoremove
437
442
438 # Unmount mounted filesystems
443 # Unmount mounted filesystems
439 umount -l "${R}/proc"
444 umount -l "${R}/proc"
440 umount -l "${R}/sys"
445 umount -l "${R}/sys"
441
446
442 # Clean up directories
447 # Clean up directories
443 rm -rf "${R}/run/*"
448 rm -rf "${R}/run/*"
444 rm -rf "${R}/tmp/*"
449 rm -rf "${R}/tmp/*"
445
450
446 # Clean up files
451 # Clean up files
447 rm -f "${ETC_DIR}/ssh/ssh_host_*"
452 rm -f "${ETC_DIR}/ssh/ssh_host_*"
448 rm -f "${ETC_DIR}/dropbear/dropbear_*"
453 rm -f "${ETC_DIR}/dropbear/dropbear_*"
449 rm -f "${ETC_DIR}/apt/sources.list.save"
454 rm -f "${ETC_DIR}/apt/sources.list.save"
450 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
455 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
451 rm -f "${ETC_DIR}/*-"
456 rm -f "${ETC_DIR}/*-"
452 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
457 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
453 rm -f "${ETC_DIR}/resolv.conf"
458 rm -f "${ETC_DIR}/resolv.conf"
454 rm -f "${R}/root/.bash_history"
459 rm -f "${R}/root/.bash_history"
455 rm -f "${R}/var/lib/urandom/random-seed"
460 rm -f "${R}/var/lib/urandom/random-seed"
456 rm -f "${R}/initrd.img"
461 rm -f "${R}/initrd.img"
457 rm -f "${R}/vmlinuz"
462 rm -f "${R}/vmlinuz"
458 rm -f "${R}${QEMU_BINARY}"
463 rm -f "${R}${QEMU_BINARY}"
459
464
460 # Calculate size of the chroot directory in KB
465 # Calculate size of the chroot directory in KB
461 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
466 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
462
467
463 # Calculate the amount of needed 512 Byte sectors
468 # Calculate the amount of needed 512 Byte sectors
464 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
469 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
465 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
470 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
466 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
471 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
467
472
468 # The root partition is EXT4
473 # The root partition is EXT4
469 # This means more space than the actual used space of the chroot is used.
474 # This means more space than the actual used space of the chroot is used.
470 # As overhead for journaling and reserved blocks 25% are added.
475 # As overhead for journaling and reserved blocks 25% are added.
471 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
476 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
472
477
473 # Calculate required image size in 512 Byte sectors
478 # Calculate required image size in 512 Byte sectors
474 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
479 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
475
480
476 # Prepare date string for image file name
481 # Prepare date string for image file name
477 DATE="$(date +%Y-%m-%d)"
482 DATE="$(date +%Y-%m-%d)"
478
483
479 # Prepare image file
484 # Prepare image file
480 if [ "$ENABLE_SPLITFS" = true ] ; then
485 if [ "$ENABLE_SPLITFS" = true ] ; then
481 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
486 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
482 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
487 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
483 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
488 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
484 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
489 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
485
490
486 # Write firmware/boot partition tables
491 # Write firmware/boot partition tables
487 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" 2> /dev/null <<EOM
492 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img" 2> /dev/null <<EOM
488 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
493 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
489 EOM
494 EOM
490
495
491 # Write root partition table
496 # Write root partition table
492 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-root.img" 2> /dev/null <<EOM
497 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}-root.img" 2> /dev/null <<EOM
493 ${TABLE_SECTORS},${ROOT_SECTORS},83
498 ${TABLE_SECTORS},${ROOT_SECTORS},83
494 EOM
499 EOM
495
500
496 # Setup temporary loop devices
501 # Setup temporary loop devices
497 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-frmw.img)"
502 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-frmw.img)"
498 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-root.img)"
503 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-debian-${RELEASE}-root.img)"
499 else # ENABLE_SPLITFS=false
504 else # ENABLE_SPLITFS=false
500 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
505 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
501 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
506 dd if=/dev/zero of="$BASEDIR/${DATE}-debian-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
502
507
503 # Write partition table
508 # Write partition table
504 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}.img" 2> /dev/null <<EOM
509 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-debian-${RELEASE}.img" 2> /dev/null <<EOM
505 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
510 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
506 ${ROOT_OFFSET},${ROOT_SECTORS},83
511 ${ROOT_OFFSET},${ROOT_SECTORS},83
507 EOM
512 EOM
508
513
509 # Setup temporary loop devices
514 # Setup temporary loop devices
510 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
515 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
511 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
516 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-debian-${RELEASE}.img)"
512 fi
517 fi
513
518
514 if [ "$ENABLE_CRYPTFS" = true ] ; then
519 if [ "$ENABLE_CRYPTFS" = true ] ; then
515 # Create dummy ext4 fs
520 # Create dummy ext4 fs
516 mkfs.ext4 "$ROOT_LOOP"
521 mkfs.ext4 "$ROOT_LOOP"
517
522
518 # Setup password keyfile
523 # Setup password keyfile
519 echo -n ${CRYPTFS_PASSWORD} > .password
524 echo -n ${CRYPTFS_PASSWORD} > .password
520 chmod 600 .password
525 chmod 600 .password
521
526
522 # Initialize encrypted partition
527 # Initialize encrypted partition
523 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
528 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
524
529
525 # Open encrypted partition and setup mapping
530 # Open encrypted partition and setup mapping
526 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
531 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
527
532
528 # Secure delete password keyfile
533 # Secure delete password keyfile
529 shred -zu .password
534 shred -zu .password
530
535
531 # Update temporary loop device
536 # Update temporary loop device
532 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
537 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
533
538
534 # Wipe encrypted partition (encryption cipher is used for randomness)
539 # Wipe encrypted partition (encryption cipher is used for randomness)
535 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
540 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
536 fi
541 fi
537
542
538 # Build filesystems
543 # Build filesystems
539 mkfs.vfat "$FRMW_LOOP"
544 mkfs.vfat "$FRMW_LOOP"
540 mkfs.ext4 "$ROOT_LOOP"
545 mkfs.ext4 "$ROOT_LOOP"
541
546
542 # Mount the temporary loop devices
547 # Mount the temporary loop devices
543 mkdir -p "$BUILDDIR/mount"
548 mkdir -p "$BUILDDIR/mount"
544 mount "$ROOT_LOOP" "$BUILDDIR/mount"
549 mount "$ROOT_LOOP" "$BUILDDIR/mount"
545
550
546 mkdir -p "$BUILDDIR/mount/boot/firmware"
551 mkdir -p "$BUILDDIR/mount/boot/firmware"
547 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
552 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
548
553
549 # Copy all files from the chroot to the loop device mount point directory
554 # Copy all files from the chroot to the loop device mount point directory
550 rsync -a "${R}/" "$BUILDDIR/mount/"
555 rsync -a "${R}/" "$BUILDDIR/mount/"
551
556
552 # Unmount all temporary loop devices and mount points
557 # Unmount all temporary loop devices and mount points
553 cleanup
558 cleanup
554
559
555 # Create block map file(s) of image(s)
560 # Create block map file(s) of image(s)
556 if [ "$ENABLE_SPLITFS" = true ] ; then
561 if [ "$ENABLE_SPLITFS" = true ] ; then
557 # Create block map files for "bmaptool"
562 # Create block map files for "bmaptool"
558 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img"
563 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img"
559 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-root.img"
564 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}-root.img"
560
565
561 # Image was successfully created
566 # Image was successfully created
562 echo "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
567 echo "$BASEDIR/${DATE}-debian-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
563 echo "$BASEDIR/${DATE}-debian-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
568 echo "$BASEDIR/${DATE}-debian-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
564 else
569 else
565 # Create block map file for "bmaptool"
570 # Create block map file for "bmaptool"
566 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}.img"
571 bmaptool create -o "$BASEDIR/${DATE}-debian-${RELEASE}.bmap" "$BASEDIR/${DATE}-debian-${RELEASE}.img"
567
572
568 # Image was successfully created
573 # Image was successfully created
569 echo "$BASEDIR/${DATE}-debian-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
574 echo "$BASEDIR/${DATE}-debian-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
570 fi
575 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant